















































ifndef _WIN32_MAK_
_WIN32_MAK_ := 1





ifeq "$(CPU)"  ""
CPU := i386
endif

ifneq "$(CPU)"  "i386"
ifneq "$(CPU)"  "MIPS"
ifneq "$(CPU)"  "ALPHA"
ifneq "$(CPU)"  "PPC"
ERROR  Must specify CPU environment variable ( CPU=i386, CPU=MIPS, CPU=ALPHA, CPU=PPC)
endif
endif
endif
endif





ifndef TARGETOS
TARGETOS := WINNT
endif

ifneq "$(TARGETOS)"  "WINNT"
ifneq "$(TARGETOS)"  "WIN95"
ifneq "$(TARGETOS)"  "BOTH"
ERROR Must specify TARGETOS environment variable (BOTH, WIN95, WINNT)
endif
endif
endif


ifndef APPVER
APPVER := 4.0
endif

ifneq "$(APPVER)"  "4.0"
ifneq "$(APPVER)"  "3.51"
ERROR Must specify APPVER environment variable (3.51, 4.0)
endif
endif


cc     := cl
rc     := rc
link   := link
implib := lib
hc     := hcrtf -xn


cvtobj := REM !!! CVTOBJ is no longer necessary - please remove !!!
cvtres := REM !!! CVTRES is no longer necessary - please remove !!!




























ccommon := -c -W3 -DCRTAPI1=_cdecl -DCRTAPI2=_cdecl 



ifdef SEHMAP
ccommon := $(ccommon) -FIsehmap.h
endif

ifeq "$(TARGETLANG)"  "LANG_JAPANESE"
ccommon := $(ccommon) -DJAPAN -DDBCS -DFE_IME
endif

ifeq "$(TARGETLANG)"  "LANG_CHINESE"
ccommon := $(ccommon) -DDBCS -DFE_IME
endif

ifeq "$(TARGETLANG)"  "LANG_KOREAN"
ccommon := $(ccommon) -DDBCS -DFE_IME
endif



ifeq "$(CPU)"  "i386"
cflags := $(ccommon) -D_X86_=1
scall  := -Gz
else
ifeq "$(CPU)"  "MIPS"
cflags := $(ccommon) -D_MIPS_=1
else
ifeq "$(CPU)"  "PPC"
cflags := $(ccommon) -D_PPC_=1
else
ifeq "$(CPU)"  "ALPHA"
cflags := $(ccommon) -D_ALPHA_=1
endif
endif
endif
scall  =
endif

ifeq "$(TARGETOS)"  "WINNT"
cflags := $(cflags) -D_WINNT -D_WIN32_WINNT=0x0400
else
ifeq "$(TARGETOS)"  "WIN95"
cflags := $(cflags) -D_WIN95 -D_WIN32_WINDOWS=0x0400
endif
endif


cflags := $(cflags) -DWINVER=0x0400


ifdef NODEBUG
cdebug := -Ox
else
ifdef PROFILE
cdebug := -Gh -Zd -Ox
else
ifdef TUNE
cdebug := -Gh -Zd -Ox
else
cdebug := -Z7 -Od
endif
endif
endif












































ifdef NO_ANSI
noansi := -DNULL=0
endif


cvars      := -DWIN32 $(noansi) -D_WIN32
cvarsmt    := $(cvars) -D_MT -MT
cvarsdll   := $(cvars) -D_MT -D_DLL -MD


cvarsmtdll   := $(cvarsmt) -D_DLL


psxvars    := -D_POSIX_


rcflags := /r
rcvars := -DWIN32 -D_WIN32 -DWINVER=0x0400 $(noansi)

ifeq "$(TARGETLANG)"  "LANG_JAPANESE"
rcflags := $(rcflags) /c932
rcvars := $(rcvars) -DJAPAN -DDBCS -DFE_IME
endif

ifeq "$(TARGETLANG)"  "LANG_CHINESE"
rcvars := $(rcvars) -DDBCS -DFE_IME
endif

ifeq "$(TARGETLANG)"  "LANG_KOREAN"
rcvars := $(rcvars) -DDBCS -DFE_IME
endif



















lflags  := /NODEFAULTLIB /INCREMENTAL:NO /PDB:NONE /RELEASE 


ifeq "$(CPU)"  "i386"
DLLENTRY := @12
endif


ifeq "$(CPU)"  "MIPS"
DLLENTRY =
endif


ifeq "$(CPU)"  "PPC"
DLLENTRY =
endif


ifeq "$(CPU)"  "ALPHA"
DLLENTRY =
endif











ifdef NODEBUG
ldebug := /RELEASE
else
ifdef PROFILE
ldebug := -debug:mapped,partial -debugtype:coff
else
ifdef TUNE
ldebug := -debug:mapped,partial -debugtype:coff
else
ldebug := -debug:full -debugtype:cv
endif
endif
endif


linkdebug := $(ldebug)














conlflags := $(lflags) -subsystem:console,$(APPVER)
guilflags := $(lflags) -subsystem:windows,$(APPVER)
dlllflags := $(lflags) -entry:_DllMainCRTStartup$(DLLENTRY) -dll

ifeq "$(CPU)"  "i386"
savlflags := $(lflags) -subsystem:windows,$(APPVER) -entry:WinMainCRTStartup
else
savlflags := $(lflags) -subsystem:windows,$(APPVER) -entry:mainCRTStartup
endif


psxlflags := $(lflags) -subsystem:posix -entry:__PosixProcessStartup


conflags  := $(conlflags)
guiflags  := $(guilflags)
psxflags  := $(psxlflags)






































libc := libc.lib oldnames.lib
libcmt := libcmt.lib oldnames.lib
libcdll := msvcrt.lib oldnames.lib


psxlibs    := libcpsx.lib psxdll.lib psxrtl.lib oldnames.lib



ifdef PROFILE
optlibs :=  cap.lib
else
ifdef TUNE
optlibs := wst.lib
else
optlibs =
endif
endif


ifeq "$(TARGETOS)"  "WINNT"
ifneq "$(APPVER)"  "3.51"
winsocklibs := ws2_32.lib mswsock.lib
else
winsocklibs := wsock32.lib
endif
else
winsocklibs := wsock32.lib
endif



baselibs   := kernel32.lib $(optlibs) $(winsocklibs) advapi32.lib
winlibs    := $(baselibs) user32.lib gdi32.lib comdlg32.lib winspool.lib


conlibs    := $(libc) $(baselibs)
conlibsmt  := $(libcmt) $(baselibs)
conlibsdll := $(libcdll) $(baselibs)
guilibs    := $(libc) $(winlibs)
guilibsmt  := $(libcmt) $(winlibs)
guilibsdll := $(libcdll) $(winlibs)


olelibs      := ole32.lib uuid.lib oleaut32.lib $(guilibs)
olelibsmt    := ole32.lib uuid.lib oleaut32.lib $(guilibsmt)
olelibsdll   := ole32.lib uuid.lib oleaut32.lib $(guilibsdll)


ole2libs    := $(olelibs)
ole2libsmt  := $(olelibsmt)
ole2libsdll := $(olelibsdll)


endif 




all: simple.exe

simple.o: simple.c
	   $(cc) $(cflags) $(cvars) simple.c

simple.exe: simple.o
	   $(link) $(conflags) -out:simple.exe simple.o $(conlibs)
